"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .tooldefinition import ToolDefinition, ToolDefinitionTypedDict
from pydantic import model_serializer
from syllable_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing_extensions import NotRequired, TypedDict


class ToolUpdateRequestTypedDict(TypedDict):
    r"""Request model to update an existing tool."""

    name: str
    r"""The name of the tool"""
    definition: ToolDefinitionTypedDict
    r"""A tool that can be called from an LLM during the conversation. See https://docs.syllable.ai/Resources/Tools."""
    service_id: int
    r"""Internal ID of the service to which the tool belongs"""
    id: int
    r"""The internal ID of the tool"""
    last_updated_comments: NotRequired[Nullable[str]]
    r"""Comments for the most recent edit to the tool."""


class ToolUpdateRequest(BaseModel):
    r"""Request model to update an existing tool."""

    name: str
    r"""The name of the tool"""

    definition: ToolDefinition
    r"""A tool that can be called from an LLM during the conversation. See https://docs.syllable.ai/Resources/Tools."""

    service_id: int
    r"""Internal ID of the service to which the tool belongs"""

    id: int
    r"""The internal ID of the tool"""

    last_updated_comments: OptionalNullable[str] = UNSET
    r"""Comments for the most recent edit to the tool."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["last_updated_comments"]
        nullable_fields = ["last_updated_comments"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
